searchNodes=[{"doc":"A simple implementation of the JSON-RPC . JSON-RPC is a remote procedure call protocol encoded in JSON. It is similar to the XML-RPC protocol, defining only a few data types and commands. JSON-RPC allows for notifications (data sent to the server that does not require a response) and for multiple calls to be sent to the server which may be answered asynchronously. Getting started Add :phx_json_rpc to your dependencies { :phx_json_rpc , &quot;~&gt; 0.2.0&quot; } Usage with phoenix Configure rpc router, specifying json schema version and batch size params defmodule MyApp.Rpc.Router do use PhxJsonRpc.Router , schema : &quot;[PATH_TO_YOUR_SCHEMA]&quot; , version : &quot;2.0&quot; , max_batch_size : 20 ## Pet&#39;s service rpc ( &quot;pet.create&quot; , PetController , :create , &quot;#/components/schemas/Pet&quot; ) rpc ( &quot;pet.list&quot; , PetController , :list , &quot;#/components/schemas/Pets&quot; ) rpc ( &quot;pet.update&quot; , PetController , :update , &quot;#/components/schemas/Pet&quot; ) rpc ( &quot;pet.delete&quot; , PetController , :delete , &quot;#/components/schemas/PetId&quot; ) end Create controller for handling requests via http defmodule MyAppWeb.RpcController do use MyAppWeb , :controller alias MyApp.Rpc.Router def rpc ( conn , request ) do response = Router . handle ( request ) render ( conn , &quot;response.json&quot; , response ) end end Import helpers inside your view and define render function defmodule MyAppWeb.RpcView do use MyAppWeb , :view import PhxJsonRpc.Views.Helpers def render ( &quot;response.json&quot; , %{ response : response } ) do render_json ( response ) end end Optionally, you can import PhxJsonRpc.Views.Helpers inside the view_helpers quote block in your web.ex like so: defp view_helpers do quote do ... import PhxJsonRpcWeb.Views.Helpers end end Add endpoint path to your router under the api scope scope &quot;/api&quot; , MyAppWeb do pipe_through :api post ( &quot;/rpc&quot; , RpcController , :rpc ) end Start phoenix server and make an http request curl - X POST - H &#39;Content-Type:application/json&#39; - d &#39;{&quot;jsonrpc&quot;:&quot;2.0&quot;,&quot;id&quot;:&quot;[ID]&quot;,&quot;method&quot;:&quot;pet.create&quot;,&quot;params&quot;:{&quot;name&quot;:&quot;Kitty&quot;}}&#39; http :// localhost : 4000 / api / rpc","ref":"PhxJsonRpc.html","title":"PhxJsonRpc","type":"module"},{"doc":"Basic struct for the rpc request.","ref":"PhxJsonRpc.Request.html","title":"PhxJsonRpc.Request","type":"module"},{"doc":"Creates the new rpc request from the given params. Examples iex&gt; PhxJsonRpc.Request . new ( version : &quot;2.0&quot; , method : &quot;hello&quot; , params : %{ &quot;name&quot; =&gt; &quot;John&quot; } , id : &quot;[REQUEST-UUID]&quot; ) % PhxJsonRpc.Request { version : &quot;2.0&quot; , method : &quot;hello&quot; , params : %{ &quot;name&quot; =&gt; &quot;John&quot; } , id : &quot;[REQUEST-UUID]&quot; , valid? : nil , error : nil }","ref":"PhxJsonRpc.Request.html#new/1","title":"PhxJsonRpc.Request.new/1","type":"function"},{"doc":"Type represents structure for the rpc request.","ref":"PhxJsonRpc.Request.html#t:t/0","title":"PhxJsonRpc.Request.t/0","type":"type"},{"doc":"Basic struct for the rpc response","ref":"PhxJsonRpc.Response.html","title":"PhxJsonRpc.Response","type":"module"},{"doc":"Creates an empty rpc response. Examples iex&gt; PhxJsonRpc.Response . empty ( ) % PhxJsonRpc.Response { version : nil , data : nil , id : nil , valid? : false , error : nil }","ref":"PhxJsonRpc.Response.html#empty/1","title":"PhxJsonRpc.Response.empty/1","type":"function"},{"doc":"Creates the new rpc response from the given params. Examples iex&gt; PhxJsonRpc.Response . new ( version : &quot;2.0&quot; , data : &quot;hello&quot; , id : &quot;[REQUEST-UUID]&quot; , valid? : true ) % PhxJsonRpc.Response { version : &quot;2.0&quot; , data : &quot;hello&quot; , id : &quot;[REQUEST-UUID]&quot; , valid? : true , error : nil }","ref":"PhxJsonRpc.Response.html#new/1","title":"PhxJsonRpc.Response.new/1","type":"function"},{"doc":"Type represents structure for the rpc response.","ref":"PhxJsonRpc.Response.html#t:t/0","title":"PhxJsonRpc.Response.t/0","type":"type"},{"doc":"MetaData struct for the paths, defined in rpc router. Contains information about called controllers, actions and schema references for the given rpc method.","ref":"PhxJsonRpc.Router.MetaData.html","title":"PhxJsonRpc.Router.MetaData","type":"module"},{"doc":"Creates the new metadata from the given params. Examples iex&gt; PhxJsonRpc.Router.MetaData . new ( controller : RpcController , action : :hello , schema_ref : &quot;#/components/schema/hello&quot; ) % PhxJsonRpc.Router.MetaData { controller : RpcController , action : :hello , schema_ref : &quot;#/components/schema/hello&quot; }","ref":"PhxJsonRpc.Router.MetaData.html#new/1","title":"PhxJsonRpc.Router.MetaData.new/1","type":"function"},{"doc":"Type represents structure for the rpc metadata.","ref":"PhxJsonRpc.Router.MetaData.html#t:t/0","title":"PhxJsonRpc.Router.MetaData.t/0","type":"type"},{"doc":"Type definitions for the rpc requests, responses and errors.","ref":"PhxJsonRpc.Types.html","title":"PhxJsonRpc.Types","type":"module"},{"doc":"Parses parameters, applying defaults by the given struct.","ref":"PhxJsonRpc.Types.html#parse_params/2","title":"PhxJsonRpc.Types.parse_params/2","type":"function"},{"doc":"Type represents jsonrpc version number.","ref":"PhxJsonRpc.Types.html#t:jsonrpc_version/0","title":"PhxJsonRpc.Types.jsonrpc_version/0","type":"type"},{"doc":"Type represents possible rpc errors.","ref":"PhxJsonRpc.Types.html#t:rpc_error/0","title":"PhxJsonRpc.Types.rpc_error/0","type":"type"},{"doc":"Type represents rpc request ID. Whether it's nil, string or number.","ref":"PhxJsonRpc.Types.html#t:rpc_request_id/0","title":"PhxJsonRpc.Types.rpc_request_id/0","type":"type"},{"doc":"Type represents called rpc request method in the form of string.","ref":"PhxJsonRpc.Types.html#t:rpc_request_method/0","title":"PhxJsonRpc.Types.rpc_request_method/0","type":"type"},{"doc":"Type represents rpc request parameters. In terms of elixir, it's a list or a map.","ref":"PhxJsonRpc.Types.html#t:rpc_request_params/0","title":"PhxJsonRpc.Types.rpc_request_params/0","type":"type"},{"doc":"Type represents rpc response.","ref":"PhxJsonRpc.Types.html#t:rpc_response/0","title":"PhxJsonRpc.Types.rpc_response/0","type":"type"},{"doc":"The entrypoint for defining rpc routes. Config schema - specifies path to your json-schema file. version - jsonrpc version. max_batch_size - maximum number of requests per batch. Example defmodule MyRpcRouter do use PhxJsonRpc.Router , schema : &quot;[PATH_TO_OPENRPC_SCHEMA]&quot; , version : &quot;2.0&quot; , max_batch_size : 20 rpc ( &quot;greet&quot; , HelloController , :hello ) end","ref":"PhxJsonRpc.Router.html","title":"PhxJsonRpc.Router","type":"module"},{"doc":"Generates rpc route match based on the open-rpc schema parameters. Arguments method - the name of the calling method. controller - resolving module, often a controller. action - resolving function in controller. schema_ref - reference inside json schema, used for request params validation. Examples rpc ( &quot;hello&quot; , HelloController , :hello ) rpc ( &quot;pet_create&quot; , PetController , :create , &quot;#/components/schemas/NewPet&quot; )","ref":"PhxJsonRpc.Router.html#rpc/4","title":"PhxJsonRpc.Router.rpc/4","type":"macro"},{"doc":"Context that provides access to the stored route list, jsonrpc version and schema.","ref":"PhxJsonRpc.Router.Context.html","title":"PhxJsonRpc.Router.Context","type":"behaviour"},{"doc":"Returns the pre-resolved json-schema.","ref":"PhxJsonRpc.Router.Context.html#c:get_json_schema/0","title":"PhxJsonRpc.Router.Context.get_json_schema/0","type":"callback"},{"doc":"Returns maximum size of the batch.","ref":"PhxJsonRpc.Router.Context.html#c:get_max_batch_size/0","title":"PhxJsonRpc.Router.Context.get_max_batch_size/0","type":"callback"},{"doc":"Returns the pre-defined list of routes.","ref":"PhxJsonRpc.Router.Context.html#c:get_routes/0","title":"PhxJsonRpc.Router.Context.get_routes/0","type":"callback"},{"doc":"Returns the json rpc version number.","ref":"PhxJsonRpc.Router.Context.html#c:get_version/0","title":"PhxJsonRpc.Router.Context.get_version/0","type":"callback"},{"doc":"Type represents the list of available routes.","ref":"PhxJsonRpc.Router.Context.html#t:route_list/0","title":"PhxJsonRpc.Router.Context.route_list/0","type":"type"},{"doc":"Behaviour for the rpc requests dispatcher.","ref":"PhxJsonRpc.Router.Dispatcher.html","title":"PhxJsonRpc.Router.Dispatcher","type":"behaviour"},{"doc":"Dispatches the given rpc request, using module and action definitions in metadata. If no metadata specified, falls to method not found response.","ref":"PhxJsonRpc.Router.Dispatcher.html#c:dispatch/2","title":"PhxJsonRpc.Router.Dispatcher.dispatch/2","type":"callback"},{"doc":"Parse behaviour for the rpc requests.","ref":"PhxJsonRpc.Router.Parser.html","title":"PhxJsonRpc.Router.Parser","type":"behaviour"},{"doc":"Parses request, checking it's version, method and parameters. If parse fails, returns request with %PhxJsonRpc.Error.ParseError{} struct and set valid? parameter to false.","ref":"PhxJsonRpc.Router.Parser.html#c:parse/2","title":"PhxJsonRpc.Router.Parser.parse/2","type":"callback"},{"doc":"Behaviour for handling requests via rpc.","ref":"PhxJsonRpc.Router.Pipe.html","title":"PhxJsonRpc.Router.Pipe","type":"behaviour"},{"doc":"Handles rpc requests via the given context(router). Processes each request by the following pipeline: - parse - validate - dispatch If batch size exceeded, an exception will be rendered and requests for the current batch wont be processed.","ref":"PhxJsonRpc.Router.Pipe.html#c:handle/2","title":"PhxJsonRpc.Router.Pipe.handle/2","type":"callback"},{"doc":"Module for resolving open rpc schema.","ref":"PhxJsonRpc.Router.SchemaResolver.html","title":"PhxJsonRpc.Router.SchemaResolver","type":"module"},{"doc":"Resolves json schema by path.","ref":"PhxJsonRpc.Router.SchemaResolver.html#resolve/1","title":"PhxJsonRpc.Router.SchemaResolver.resolve/1","type":"function"},{"doc":"Validation behaviour for the rpc requests.","ref":"PhxJsonRpc.Router.Validator.html","title":"PhxJsonRpc.Router.Validator","type":"behaviour"},{"doc":"Validates the given rpc request against json-schema provided. If validation fails, enriches request with error struct and set valid? parameter to false.","ref":"PhxJsonRpc.Router.Validator.html#c:validate/3","title":"PhxJsonRpc.Router.Validator.validate/3","type":"callback"},{"doc":"Helper module provides a set of render functions for the phoenix views.","ref":"PhxJsonRpcWeb.Views.Helpers.html","title":"PhxJsonRpcWeb.Views.Helpers","type":"module"},{"doc":"Renders json rpc responses. ## Examples iex&gt; PhxJsonRpcWeb.Views.Helpers . render_json ( [ ...&gt; % PhxJsonRpc.Response { version : &quot;2.0&quot; , id : &quot;ID1&quot; , data : %{ name : &quot;Ron&quot; } , valid? : true } , ...&gt; % PhxJsonRpc.Response { version : &quot;2.0&quot; , id : &quot;ID2&quot; , error : % PhxJsonRpc.Error.ServerError { ...&gt; code : - 32000 , message : &quot;Server error&quot; } , valid? : false } ] ) [ %{ &quot;id&quot; =&gt; &quot;ID1&quot; , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; , &quot;result&quot; =&gt; %{ name : &quot;Ron&quot; } } , %{ &quot;error&quot; =&gt; %{ &quot;code&quot; =&gt; - 32000 , &quot;data&quot; =&gt; nil , &quot;message&quot; =&gt; &quot;Server error&quot; } , &quot;id&quot; =&gt; &quot;ID2&quot; , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; } ] iex&gt; PhxJsonRpcWeb.Views.Helpers . render_json ( ...&gt; % PhxJsonRpc.Response { ...&gt; version : &quot;2.0&quot; , ...&gt; id : &quot;ID&quot; , ...&gt; data : %{ name : &quot;Ron&quot; } , ...&gt; valid? : true } ...&gt; ) %{ &quot;id&quot; =&gt; &quot;ID&quot; , &quot;jsonrpc&quot; =&gt; &quot;2.0&quot; , &quot;result&quot; =&gt; %{ name : &quot;Ron&quot; } }","ref":"PhxJsonRpcWeb.Views.Helpers.html#render_json/1","title":"PhxJsonRpcWeb.Views.Helpers.render_json/1","type":"function"},{"doc":"An abstract json rpc error.","ref":"PhxJsonRpc.Error.html","title":"PhxJsonRpc.Error","type":"module"},{"doc":"Internal JSON-RPC error.","ref":"PhxJsonRpc.Error.InternalError.html","title":"PhxJsonRpc.Error.InternalError","type":"exception"},{"doc":"Type that represents error struct with :code and :message required.","ref":"PhxJsonRpc.Error.InternalError.html#t:t/0","title":"PhxJsonRpc.Error.InternalError.t/0","type":"type"},{"doc":"Invalid method parameter(s).","ref":"PhxJsonRpc.Error.InvalidParams.html","title":"PhxJsonRpc.Error.InvalidParams","type":"exception"},{"doc":"Type that represents error struct with :code and :message required.","ref":"PhxJsonRpc.Error.InvalidParams.html#t:t/0","title":"PhxJsonRpc.Error.InvalidParams.t/0","type":"type"},{"doc":"The JSON sent is not a valid Request object.","ref":"PhxJsonRpc.Error.InvalidRequest.html","title":"PhxJsonRpc.Error.InvalidRequest","type":"exception"},{"doc":"Type that represents error struct with :code and :message required.","ref":"PhxJsonRpc.Error.InvalidRequest.html#t:t/0","title":"PhxJsonRpc.Error.InvalidRequest.t/0","type":"type"},{"doc":"The method does not exist / is not available.","ref":"PhxJsonRpc.Error.MethodNotFound.html","title":"PhxJsonRpc.Error.MethodNotFound","type":"exception"},{"doc":"Type that represents error struct with :code and :message required.","ref":"PhxJsonRpc.Error.MethodNotFound.html#t:t/0","title":"PhxJsonRpc.Error.MethodNotFound.t/0","type":"type"},{"doc":"An error occurred on the server while parsing the JSON text.","ref":"PhxJsonRpc.Error.ParseError.html","title":"PhxJsonRpc.Error.ParseError","type":"exception"},{"doc":"Type that represents error struct with :code and :message required.","ref":"PhxJsonRpc.Error.ParseError.html#t:t/0","title":"PhxJsonRpc.Error.ParseError.t/0","type":"type"},{"doc":"Reserved for implementation-defined server-errors.","ref":"PhxJsonRpc.Error.ServerError.html","title":"PhxJsonRpc.Error.ServerError","type":"exception"},{"doc":"Type that represents error struct with :code and :message required.","ref":"PhxJsonRpc.Error.ServerError.html#t:t/0","title":"PhxJsonRpc.Error.ServerError.t/0","type":"type"},{"doc":"Simple implementation of JSON-RPC server, working with phoenix . Allows you to define any number of rpc endpoints, with simple access via http protocol. Endpoint can handle batches in asyncronous order.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding phx_json_rpc to your list of dependencies in mix.exs : def deps do [ { :phx_json_rpc , &quot;~&gt; 0.2.0&quot; } ] end This package depends on ex_json_schema for validation purposes.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Please see this guide for usage with phoenix.","ref":"readme.html#quick-start","title":"Overview - Quick start","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/phx_json_rpc .","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"The package creation was inspired by some other repos: json-rpc-laravel open-rpc phoenix1.4-json-rpc","ref":"readme.html#links","title":"Overview - Links","type":"extras"},{"doc":"MIT. Please see the license file for more information.","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"Copyright (c) Nickolai Shirokov shirokovnv@gmail.com Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"All notable changes to PhxJsonRpc will be documented in this file.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Maximum batch size limit property Fixed Typespecs in pipe section","ref":"changelog.html#version-0-2-0","title":"Changelog - Version 0.2.0","type":"extras"},{"doc":"Added Link to phoenix framework in README.md Fixed Unneccessary condition, when accessing metadata in pipe Documentation in error section","ref":"changelog.html#version-0-1-1","title":"Changelog - Version 0.1.1","type":"extras"},{"doc":"Added Initial commit","ref":"changelog.html#version-0-1-0","title":"Changelog - Version 0.1.0","type":"extras"}]